//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1 LimeGreen
#property indicator_color2 Silver
#property indicator_color3 Silver
#property indicator_color4 Orange
#property indicator_color5 Orange
#property indicator_color6 Tan
#property indicator_level1 100

#property indicator_levelcolor Silver  

//
//
//
//
//

extern string TimeFrame    = "Current time frame";
extern int    WprPeriod    = 32;
extern int    MaPeriod     = 8 ;
extern int    Smooth       = 5;
extern int    WprLineWidth = 2;
extern int    MaLineWidth  = 1;
extern bool   Interpolate  = true;

double WprUp[];
double WprCa[];
double WprCb[];
double WprDa[];
double WprDb[];
double Ma[];
double mainTrend[];
double trend[];

//
//
//
//
//

string indicatorFileName;
int    timeFrame;
bool   returnBars;
bool   calculateValue;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,WprUp);
   SetIndexBuffer(1,WprCa);
   SetIndexBuffer(2,WprCb);
   SetIndexBuffer(3,WprDa);
   SetIndexBuffer(4,WprDb);
   SetIndexBuffer(5,Ma);
   SetIndexBuffer(6,trend);
   SetIndexBuffer(7,mainTrend);
   
   for (int i=0; i<5; i++) SetIndexStyle(i,EMPTY,EMPTY,WprLineWidth);
                           SetIndexStyle(i,EMPTY,EMPTY,MaLineWidth);

   //
   //
   //
   //
   //

      indicatorFileName = WindowExpertName();
      calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);

   //
   //
   //
   //
   //

   IndicatorShortName(timeFrameToString(timeFrame)+" wpr ma ("+WprPeriod+","+MaPeriod+")");
   return(0); 
}   
int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars = IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { WprUp[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame==Period())
   {
      if (mainTrend[limit] == 0) CleanPoint(limit,WprCa,WprCb);
      if (mainTrend[limit] <  0) CleanPoint(limit,WprDa,WprDb);
      for(int i=limit; i>=0; i--)
      {
         WprCa[i] = EMPTY_VALUE;
         WprCb[i] = EMPTY_VALUE;
         WprDa[i] = EMPTY_VALUE;
         WprDb[i] = EMPTY_VALUE;
         WprUp[i] = iSsm(iWPR(NULL,0,WprPeriod,i)+100.0,Smooth,i);
         Ma[i]    = WprUp[i];
            for (int l=1; l<MaPeriod; l++) Ma[i] += WprUp[i+l];
                                           Ma[i] /= MaPeriod;

         //
         //
         //
         //
         //
         
         trend[i]     = trend[i+1];
            if (Ma[i]<WprUp[i]) trend[i] =  1;
            if (Ma[i]>WprUp[i]) trend[i] = -1;
         mainTrend[i] = trend[i]+trend[i+1];
            if (mainTrend[i] == 0) PlotPoint(i,WprCa,WprCb,WprUp);
            if (mainTrend[i] <  0) PlotPoint(i,WprDa,WprDb,WprUp); 
      }
      return(0);
   }

   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   if (mainTrend[limit] == 0) CleanPoint(limit,WprCa,WprCb);
   if (mainTrend[limit] <  0) CleanPoint(limit,WprDa,WprDb);
   for (i=limit;i>=0;i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         mainTrend[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",WprPeriod,MaPeriod,Smooth,7,y);
         Ma[i]        = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",WprPeriod,MaPeriod,Smooth,5,y);
         WprUp[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",WprPeriod,MaPeriod,Smooth,0,y);
         WprCa[i]     = EMPTY_VALUE;
         WprCb[i]     = EMPTY_VALUE;
         WprDa[i]     = EMPTY_VALUE;
         WprDb[i]     = EMPTY_VALUE;

         //
         //
         //
         //
         //
      
         if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,timeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(int k = 1; k < n; k++)
            {
               WprUp[i+k] = WprUp[i] + (WprUp[i+n]-WprUp[i])*k/n;
               Ma[i+k]    = Ma[i]    + (Ma[i+n]   -Ma[i]   )*k/n;
            }
   }
   for (i=limit;i>=0;i--)
   {
      if (mainTrend[i] == 0) PlotPoint(i,WprCa,WprCb,WprUp);
      if (mainTrend[i] <  0) PlotPoint(i,WprDa,WprDb,WprUp); 
   }
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if (i>Bars-2) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>Bars-3) return;
   if (first[i+1] == EMPTY_VALUE)
         if (first[i+2] == EMPTY_VALUE) 
               { first[i]  = from[i]; first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
         else  { second[i] = from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else        { first[i]  = from[i];                          second[i] = EMPTY_VALUE; }
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

int stringToTimeFrame(string tfs)
{
   StringToUpper(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

#define Pi 3.14159265358979323846264338327950288
double workSsm[][2];
#define _tprice  0
#define _ssm    1

double workSsmCoeffs[][4];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3

//
//
//
//
//

double iSsm(double price, double period, int i, int instanceNo=0)
{
   if (period<=1) return(price);
   if (ArrayRange(workSsm,0) !=Bars)                 ArrayResize(workSsm,Bars);
   if (ArrayRange(workSsmCoeffs,0) < (instanceNo+1)) ArrayResize(workSsmCoeffs,instanceNo+1);
   if (workSsmCoeffs[instanceNo][_period] != period)
   {
      workSsmCoeffs[instanceNo][_period] = period;
      double a1 = MathExp(-1.414*Pi/period);
      double b1 = 2.0*a1*MathCos(1.414*Pi/period);
         workSsmCoeffs[instanceNo][_c2] = b1;
         workSsmCoeffs[instanceNo][_c3] = -a1*a1;
         workSsmCoeffs[instanceNo][_c1] = 1.0 - workSsmCoeffs[instanceNo][_c2] - workSsmCoeffs[instanceNo][_c3];
   }

   //
   //
   //
   //
   //

      int s = instanceNo*2;   
      i = Bars-i-1;
          workSsm[i][s+_tprice] = price;
          if (i<2)
               workSsm[i][s+_ssm] = price;
          else workSsm[i][s+_ssm]  = workSsmCoeffs[instanceNo][_c1]*(workSsm[i][s+_tprice]+workSsm[i-1][s+_tprice])/2.0 + 
                                     workSsmCoeffs[instanceNo][_c2]*workSsm[i-1][s+_ssm]                                + 
                                     workSsmCoeffs[instanceNo][_c3]*workSsm[i-2][s+_ssm]; 
   return(workSsm[i][s+_ssm]);
}